local addonName, addon = ...

local origAddRaidEP;

CEPGP_ZA = {

	enabled = true,
	zoneAward = true,
	suppressMessages = false,
	includeKills = false,

};

-- Hook original AddRaidEP function

function CEPGP_ZA_hook()
	origAddRaidEP = CEPGP_AddRaidEP;
	CEPGP_AddRaidEP = function(...)
		local amount, msg, encounter = ...;
		local ZA_GuildRoster = "";
		local ZA_RaidRoster = "";
		if CEPGP_Info.Guild then
			ZA_GuildRoster = CEPGP_Info.Guild.Roster or CEPGP_roster;
		else
			ZA_GuildRoster = CEPGP_roster;
		end
		if CEPGP_Info.Raid then
			ZA_RaidRoster = CEPGP_Info.Raid.Roster or CEPGP_raidRoster;
		else
			ZA_RaidRoster = CEPGP_raidRoster;
		end
		if CEPGP_ZA.enabled and ((CEPGP_ZA.zoneAward and not encounter) or (encounter and CEPGP_ZA.includeKills)) then	
			amount = math.floor(amount);
			local function callback()
				local success, failMsg = pcall(function()
					local myzone = GetRealZoneText();
					local total = GetNumGroupMembers();
					local notInZone = {};
					--CEPGP_Info.IgnoreUpdates = true;
					--CEPGP_SendAddonMsg("?IgnoreUpdates;true", "GUILD");
					
					local roster = {};
					
					for _, v in pairs(ZA_RaidRoster) do
						roster[v[1]] = "";
					end
					
					local function update()
						if msg ~= "" and msg ~= nil or encounter then
							if encounter then -- a boss was killed
								CEPGP_addTraffic("Raid", UnitName("player"), "Add Raid EP +" .. amount .. " to those in " ..myzone .. " - " .. encounter, "", "", "", "", "", time());
								CEPGP_sendChatMessage(msg, CEPGP.Channel);
							else -- EP was manually given, could be either positive or negative, and a message was written
								if tonumber(amount) <= 0 then
									CEPGP_addTraffic("Raid", UnitName("player"), "Subtract Raid EP -" .. amount .. " from those in " .. myzone .. " (" .. msg .. ")", "", "", "", "", "", time());
									CEPGP_sendChatMessage(amount .. " EP taken from all raid members in " .. myzone .. "(" .. msg .. ")", CEPGP.Channel);
								else
									CEPGP_addTraffic("Raid", UnitName("player"), "Add Raid EP +" .. amount .. " to those in " .. myzone .. " (" .. msg .. ")", "", "", "", "", "", time());
									CEPGP_sendChatMessage(amount .. " EP awarded to all raid members in " .. myzone .. " (" .. msg .. ")", CEPGP.Channel);
								end
							end
						else -- no message was written
							if tonumber(amount) <= 0 then
								amount = string.sub(amount, 2, string.len(amount));
								CEPGP_addTraffic("Raid", UnitName("player"), "Subtract Raid EP -" .. amount .. " to those in " .. myzone, "", "", "", "", "", time());
								CEPGP_sendChatMessage(amount .. " EP taken from all raid members in " .. myzone, CEPGP.Channel);
							else
								CEPGP_addTraffic("Raid", UnitName("player"), "Add Raid EP +" .. amount .. " to those in " .. myzone, "", "", "", "", "", time());
								CEPGP_sendChatMessage(amount .. " EP awarded to all raid members in " .. myzone, CEPGP.Channel);
							end
						end
						if _G["CEPGP_traffic"]:IsVisible() then
							CEPGP_UpdateTrafficScrollBar();
						end
						if not CEPGP_ZA.suppressMessages and #notInZone > 0 then
							local msgtable = {};
							msgtable[1] = "People who didn't qualify for award: ";
							local j = 1;
							for _, v in ipairs(notInZone) do
								if strlen(msgtable[j] .. v .. ", ") > 255 then
									j = j +1;
									msgtable[j] = v;
								else
									msgtable[j] = msgtable[j] .. v .. ", ";
								end					
							end
							msgtable[#msgtable] = strtrim(msgtable[#msgtable], ", ");
							for _, v in ipairs(msgtable) do
								CEPGP_sendChatMessage(v, CEPGP.Channel);
							end
						end
						C_Timer.After(2, function()
							--CEPGP_Info.IgnoreUpdates = false;
							--CEPGP_SendAddonMsg("?IgnoreUpdates;false", "GUILD");
							CEPGP_rosterUpdate("GUILD_ROSTER_UPDATE");
						end);
					end
					
					local i = 0;
					local mains = {};
					C_Timer.NewTicker(0.0001, function()
						i = i + 1;
						local EP, GP, EPB;
						local name, _, _, _, _, _, zone, _, _, _, _ = GetRaidRosterInfo(i);
						if myzone == zone then
							if ZA_GuildRoster[name] then
								local index = CEPGP_getIndex(name);
								local main = CEPGP_getMain(name);
								
								if main then
									for v, _ in pairs(mains) do
										if v == main then
											return;
										end
									end
									if not roster[main] then
										mains[main] = name;
									end
								else
									EP, GP = CEPGP_getEPGP(name, index);
									EPB = EP;
									EP = math.max(math.floor(EP + amount), 0);
									GP = math.max(math.floor(GP), CEPGP.GP.Min);
									GuildRosterSetOfficerNote(index, EP .. "," .. GP);
									if CEPGP.Alt.Links[name] and not mains[name] then
										mains[name] = {};
									end
								end
							end
						else
							table.insert(notInZone, name);
						end
						if i == total then
							C_Timer.After(2, function()
								for main, alt in pairs(mains) do
									if #mains[main] == 0 then
										CEPGP_syncAltStandings(main);
									else
										CEPGP_addAltEPGP(amount, 0, alt, main);
									end
								end
							end);
							sort(notInZone);
							update();
						end
					end, total);
				end);

				if not success then
					CEPGP_print("A problem was encountered while awarding EP to the raid", true);
					CEPGP_print(failMsg, true);
				end

			end
			
			-- Removed as of CEPGP version 1.12.26
			--[[
			local Guildmembers = GetNumGuildMembers();
			if CEPGP_Info.NumExcluded then
				Guildmembers = Guildmembers - CEPGP_Info.NumExcluded;
			end]]

			--[[if CEPGP_ntgetn(ZA_GuildRoster) < Guildmembers and CEPGP_Info.Polling then
				CEPGP_print("Scanning guild roster. Raid EP will be applied soon.");
				if encounter then
					CEPGP_Info.RosterStack["BossEP"] = callback;
				else
					CEPGP_Info.RosterStack["RaidEP"] = callback;
				end
			else]]--
				callback();
			--end
		else
			origAddRaidEP(amount, msg, encounter);
		end
	end
end

function CEPGP_ZA_initialise()

	-- Initialise saved variables

	if CEPGP_ZA.enabled == nil then
		CEPGP_ZA.enabled = true;
	end

	if CEPGP_ZA.enabled then
		_G["CEPGP_ZA_award_raid_popup"]:Show();
	else
		_G["CEPGP_ZA_award_raid_popup"]:Hide();
	end

	--[[]
	if CEPGP_ZA.zoneAward then
		CEPGP_ZA_award_raid_popup_zone_check:SetChecked(true);
	else
		CEPGP_ZA_award_raid_popup_zone_check:SetChecked(false);
	end
	]]
	CEPGP_ZA_award_raid_popup_zone_check:SetChecked(CEPGP_ZA.zoneAward);

	-- Create interface options panel

	local panel = CreateFrame("FRAME");
	panel.name = "CEPGP Zone Awards";

	local titleText = panel:CreateFontString("CEPGP_ZA_titleText", "OVERLAY", "GameFontNormalLarge");
	titleText:SetPoint("TOPLEFT", panel, "TOPLEFT", 15, -15);
	titleText:SetText("CEPGP Zone Awards");

	local suppressMessagesCheck = CreateFrame("CheckButton", "CEPGP_ZA_suppressMessagesCheck", panel, "UIOptionsCheckButtonTemplate");
	suppressMessagesCheck:SetPoint("TOPLEFT", titleText, "BOTTOMLEFT", 0, -10);
	suppressMessagesCheck:SetScript("OnClick", function()
													--[[]
													if CEPGP_ZA_suppressMessagesCheck:GetChecked() then
															CEPGP_ZA.suppressMessages = true;
													else
															CEPGP_ZA.suppressMessages = false;
													end
													]]
													CEPGP_ZA.suppressMessages = CEPGP_ZA_suppressMessagesCheck:GetChecked();
											   end);
	--[[											   
	if CEPGP_ZA.suppressMessages then
		suppressMessagesCheck:SetChecked(true);
	else
		suppressMessagesCheck:SetChecked(false);
	end
	]]

	suppressMessagesCheck:SetChecked(CEPGP_ZA.suppressMessages);

	local supressMessagesText = panel:CreateFontString("CEPGP_ZA_suppressMessagesText", "OVERLAY", "GameFontNormal");
	supressMessagesText:SetPoint("LEFT", suppressMessagesCheck, "RIGHT", 5, 0);
	supressMessagesText:SetTextColor(1,1,1);
	supressMessagesText:SetText("Supress 'Not in zone' messages");

	local includeKillsCheck = CreateFrame("CheckButton", "CEPGP_ZA_includeKillsCheck", panel, "UIOptionsCheckButtonTemplate");
	includeKillsCheck:SetPoint("TOPLEFT", suppressMessagesCheck, "BOTTOMLEFT", 0, -10);
	includeKillsCheck:SetScript("OnClick", function()
													--[[]
													if CEPGP_ZA_includeKillsCheck:GetChecked() then
															CEPGP_ZA.includeKills = true;
													else
														CEPGP_ZA.includeKills = false;
													end
													]]
													CEPGP_ZA.includeKills = CEPGP_ZA_includeKillsCheck:GetChecked();
											   end);
	--[[]
	if CEPGP_ZA.includeKills then
		includeKillsCheck:SetChecked(true);
	else
		includeKillsCheck:SetChecked(false);
	end
	]]

	includeKillsCheck:SetChecked(CEPGP_ZA.includeKills);

	local includeKillsText = panel:CreateFontString("CEPGP_ZA_includeKillsText", "OVERLAY", "GameFontNormal");
	includeKillsText:SetPoint("LEFT", includeKillsCheck, "RIGHT", 5, 0);
	includeKillsText:SetTextColor(1,1,1);
	includeKillsText:SetText("Include boss kill auto awards");
	InterfaceOptions_AddCategory(panel);

	-- Register plugin with CEPGP

	CEPGP_addPlugin(addonName, panel, CEPGP_ZA.enabled, function()
		if CEPGP_ZA.enabled then
			_G["CEPGP_ZA_award_raid_popup"]:Hide();
		else
			_G["CEPGP_ZA_award_raid_popup"]:Show();
		end
		CEPGP_ZA.enabled = not CEPGP_ZA.enabled;
	end);

	CEPGP_ZA_hook();
end

function CEPGP_ZA_OnEvent(self, event, arg1)
	if event == "ADDON_LOADED" and arg1 == "CEPGP_ZA" then
		self:UnregisterEvent("ADDON_LOADED");
		CEPGP_ZA_initialise();
	end
end

local function CEPGP_ZA_createFrames()
	local CEPGP_ZA_frame = CreateFrame("Frame", "CEPGP_ZA_award_raid_popup", _G["CEPGP_award_raid_popup"]);
	CEPGP_ZA_frame:SetScale(1.0);
	local fontString = CEPGP_ZA_frame:CreateFontString("CEPGP_ZA_textFrame", "OVERLAY", "GameFontNormal");
	fontString:SetPoint("LEFT", "CEPGP_award_raid_popup_standby_check", "RIGHT", 5, 0);
	fontString:SetText("Award to Zone: ");

	local checkFrame = CreateFrame("CheckButton", "CEPGP_ZA_award_raid_popup_zone_check", CEPGP_ZA_frame, "UIOptionsCheckButtonTemplate");
	checkFrame:SetPoint("LEFT", "CEPGP_ZA_textFrame", "RIGHT", 5, 0);
	checkFrame:SetScript("OnClick",function() if _G["CEPGP_ZA_award_raid_popup_zone_check"]:GetChecked() then
												CEPGP_ZA.zoneAward = true;
											  else
												CEPGP_ZA.zoneAward = false;
											  end
								   end);
	
	CEPGP_ZA_frame:RegisterEvent("ADDON_LOADED");
	CEPGP_ZA_frame:SetScript("OnEvent", CEPGP_ZA_OnEvent);
end

CEPGP_ZA_createFrames();

